package cn.estsh.i3plus.core.apiservice.schedulejob;

import cn.estsh.i3plus.core.api.iservice.busi.ISysTaskTimeService;
import cn.estsh.impp.framework.base.schedule.BaseImppScheduleJob;
import cn.estsh.impp.framework.boot.init.ApplicationProperties;
import io.swagger.annotations.ApiOperation;
import org.quartz.JobExecutionContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @Description :  定时任务
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-09-30 13:25
 * @Modify:
 **/
@ApiOperation("定时任务demo")
public class DemoJob extends BaseImppScheduleJob {
    public static final Logger LOGGER = LoggerFactory.getLogger(DemoJob.class);

    @Autowired
    private ISysTaskTimeService taskTimeService;

    public DemoJob() {
        super(DemoJob.class,"定时任务demo");
    }

    @Override
    public void executeImppJob(JobExecutionContext context, ApplicationProperties applicationProperties) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:dd");

        taskTimeService.doSysTaskTimeLastDateByNameAndGroupName(sdf.format(new Date()),
                context.getJobDetail().getKey().getName(),
                context.getJobDetail().getKey().getGroup());
        System.out.println("定时任务被执行");
        LOGGER.info("projectName：{},port:{}",applicationProperties.getApplicationName(),applicationProperties.getServerPort());
    }
}
