package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysLogOperateService;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.platform.bean.SysLogOperate;
import cn.estsh.i3plus.pojo.platform.repositorymongo.SysLogOperateRepository;
import cn.estsh.i3plus.pojo.platform.sqlpack.CoreBsonPack;
import org.bson.conversions.Bson;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 操作日志服务接口实现
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-25 13:54
 * @Modify :
 **/
@Service
public class SysLogOperateService implements ISysLogOperateService {
    
    public static final Logger LOGGER = LoggerFactory.getLogger(SysLogOperateService.class);

    @Autowired
    public SysLogOperateRepository logOperateRDao;

    @Override
    public SysLogOperate insertSysLogOperate(SysLogOperate logOperate) {
        return logOperateRDao.insert(logOperate);
    }

    @Override
    public void deleteSysLogOperateById(Long id) {
        logOperateRDao.deleteById(id);
    }

    @Override
    public List listSysLogOperate() {
        return logOperateRDao.listPager(null);
    }

    @Override
    public void deleteSysLogOperateByIds(Long[] ids) {
        for(Long id : ids){
            logOperateRDao.deleteById(id);
        }
    }

    @Override
    public SysLogOperate getSysLogOperateById(Long id) {
        return logOperateRDao.getById(id);
    }

    @Override
    public List<SysLogOperate> listSysLogOperateByOperateUserName(String operateUserName) {
        return logOperateRDao.findByProperty("operateUserName",operateUserName);
    }

    @Override
    public long countAllSysLogOperate() {
        return logOperateRDao.listCount();
    }

    @Override
    public ListPager<SysLogOperate> querySysLogOperateByPager(SysLogOperate logOperate, Pager pager) {
        if(logOperate == null) {
            pager = PagerHelper.getPager(pager, (int) logOperateRDao.count());
            return new ListPager(logOperateRDao.findAll(),pager);
        }else{
            Bson bson = CoreBsonPack.packBsonByLogOperate(logOperate);
            pager = PagerHelper.getPager(pager,(int)logOperateRDao.findByBsonCount(bson));
            //分页，排序
            return new ListPager(logOperateRDao.findByBsonPager(bson,pager,logOperate.getOrderByParam(),logOperate.getAscOrDesc()),pager);
        }
    }
}
